#include "matrix.cpp"
int **a=NULL;
int **b=NULL;
int **c=NULL;

void strassen(int,int,int);
int main()
{
    int i,j,order;
    cout << "Enter your matrix order ( Powers of 2 ) :";
    cin >> order;
    
    //Allocate enough memory to store initial n*n matrices A,B,C
    a=new int*[order];
    b=new int*[order];
    c=new int*[order];
    for(i=0;i<order;i++)
    {
            a[i]= new int[order];
            b[i]= new int[order]; 
            c[i]= new int[order]; 
    }                      
    /// Read both the matrices A and B
    cout << "Enter matrix A : " ;
    for(i=0;i<order;i++)
            for(j=0;j<order;j++)
                    cin >> a[i][j];
    cout << "Enter matrix B : " ;
    for(i=0;i<order;i++)
            for(j=0;j<order;j++)
                    cin >> b[i][j];
    /// Now we call Strassen function to multiply matrix A & B , storing them in C        
    strassen(order,0,0);
    /// We print the resultant matrix ( Matrix C )
    cout << "The resultant matrix is : " << endl ;
    for(int i=0;i<order;i++)
    {
          for(int j=0;j<order;j++)
                      cout << c[i][j] << "\t";
              cout << endl;
    }     
    /////// End of the program    
    system("pause");
    
    
 return 0;   
 
 
}


void strassen(int n,int i , int j)
{
     if(n==2)
     {
          //Ordinary Matrix multiplication
          CMatrix A(a,i,j);CMatrix B(b,i,j);
          CMatrix C=A*B;
          C.Wback(c,0,0);
          //cout << C;
             
     }
     else if (n==4)
     {
          //Reading initial matrices from the global memory
          CMatrix A11(a,i,j);CMatrix A12(a,i,j+2);CMatrix A21(a,i+2,j);CMatrix A22(a,i+2,j+2);
          CMatrix B11(b,i,j);CMatrix B12(b,i,j+2);CMatrix B21(b,i+2,j);CMatrix B22(b,i+2,j+2);
                    
          //Strassen's matrix multiplication
          CMatrix M1 = (A11 + A22) * (B11 + B22);
          CMatrix M2 = (A21 + A22) * B11;
          CMatrix M3 = A11 * (B12 - B22);
          CMatrix M4 = A22 * ( B21 - B11);
          CMatrix M5 = (A11 + A12) * B22;
          CMatrix M6 = (A21 - A11) * (B11 + B12);
          CMatrix M7 = (A12 - A22) * (B21 + B22);
          
          CMatrix C11 = M1 + M4 - M5 + M7;
          CMatrix C12 = M3 + M5;
          CMatrix C21 = M2 + M4;
          CMatrix C22 = M1 - M2 + M3 + M6; 
          
          //Writing the results back to the global memory
          C11.Wback(c,i,j);C12.Wback(c,i,j+2);C21.Wback(c,i+2,j);C22.Wback(c,i+2,j+2);
            
     }
     else
     {
          //Recursive strassen calls           
          strassen(n/2,i,j);
          strassen(n/2,i+n/2,j);
          strassen(n/2,i,j+n/2);
          strassen(n/2,i+n/2,j+n/2);
         
     }     
}
