#include<iostream.h>
#include "CMatrix.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CMatrix CMatrix::operator+(const CMatrix& m)
{
      CMatrix result=*this;
      result.array[0][0] = array[0][0] + m.array[0][0];
      result.array[0][1] = array[0][1] + m.array[0][1];
      result.array[1][0] = array[1][0] + m.array[1][0];
      result.array[1][1] = array[1][1] + m.array[1][1];
      return result;
          
}

CMatrix CMatrix::operator-(const CMatrix& m)
{
      CMatrix result=*this;
      result.array[0][0] = array[0][0] - m.array[0][0];
      result.array[0][1] = array[0][1] - m.array[0][1];
      result.array[1][0] = array[1][0] - m.array[1][0];
      result.array[1][1] = array[1][1] - m.array[1][1];
      return result;
          
}

CMatrix CMatrix::operator*(const CMatrix& m)
{
      CMatrix result=*this;
      result.array[0][0] = (array[0][0] * m.array[0][0]) + (array[0][1]*m.array[1][0]);
      result.array[0][1] = (array[0][0] * m.array[0][1]) + (array[0][1]*m.array[1][1]);
      result.array[1][0] = (array[1][0] * m.array[0][0]) + (array[1][1]*m.array[1][0]);
      result.array[1][1] = (array[1][0] * m.array[0][1]) + (array[1][1]*m.array[1][1]);
      return result;
          
}

CMatrix& CMatrix::operator=(const CMatrix& m)
{
      if(this!=&m)
      {                    
          array[0][0] =  m.array[0][0]; 
          array[0][1] =  m.array[0][1]; 
          array[1][0] =  m.array[1][0];
          array[1][1] =  m.array[1][1]; 
      }
      return *this;
          
}

void CMatrix::Wback(int **mem,int i,int j)
{
      mem[i][j]=array[0][0];
      mem[i][j+1]=array[0][1];
      mem[i+1][j]=array[1][0];
      mem[i+1][j+1]=array[1][1];
}

ostream& operator<<(ostream& out,const CMatrix& m)
{
      for(int i=0;i<2;i++)
      {
              for(int j=0;j<2;j++)
                      out << m.array[i][j] << "\t";
              out << endl;
      }
      
      return out;
          
}
